package power;

import java.awt.event.*;
import javax.swing.*;
import java.awt.*;
import java.text.NumberFormat;
import java.util.ArrayList;

public class PowerFrame extends JFrame implements ActionListener {
    private JLabel lblTitle = new JLabel();
    private JLabel lblCorrelation1 = new JLabel();
    private JTextField txtCorrelation1 = new JTextField();
    private JLabel lblCorrelation2 = new JLabel();
    private JTextField txtCorrelation2 = new JTextField();
    private JLabel lblSampleSize1 = new JLabel();
    private JTextField txtSampleSize1 = new JTextField();
    private JLabel lblSampleSize2 = new JLabel();
    private JTextField txtSampleSize2 = new JTextField();
    private JButton btnOK = new JButton();
    private JButton btnExit = new JButton();
    private JButton btnClear = new JButton();
    private JButton btnPrint = new JButton();
    private JLabel lblResult = new JLabel();
    private JTextArea txtResult = new JTextArea(6, 1);

    private double corr1, corr2, sample1, sample2, estimate;

    //initiate the components
    public PowerFrame() {
        this.getContentPane().setLayout(null);
        this.getContentPane().setBackground(Color.white);
        this.setSize(new Dimension(500, 490));
        this.setTitle("Estimated Statistical Power");

        lblTitle.setText("Enter the following values");
        lblTitle.setBounds(new Rectangle(185, 10, 265, 20));
        lblTitle.setFont(new Font("Dialog", 1, 14));

        lblCorrelation1.setText("Correlation between variables X and Y for subgroup 1 :");
        lblCorrelation1.setBounds(new Rectangle(10, 25, 355, 40));
        txtCorrelation1.setText("");
        txtCorrelation1.setBounds(new Rectangle(325, 40, 90, 20));

        lblCorrelation2.setText("Correlation between variables X and Y for subgroup 2 :");
        lblCorrelation2.setBounds(new Rectangle(10, 65, 355, 40));
        txtCorrelation2.setText("");
        txtCorrelation2.setBounds(new Rectangle(325, 70, 90, 20));

        lblSampleSize1.setText("Sample size for subgroup 1 :");
        lblSampleSize1.setBounds(new Rectangle(10, 100, 200, 40));
        txtSampleSize1.setText("");
        txtSampleSize1.setBounds(new Rectangle(185, 110, 85, 20));

        lblSampleSize2.setText("Sample Size for subgroup 2 :");
        lblSampleSize2.setBounds(new Rectangle(10, 135, 200, 40));
        txtSampleSize2.setText("");
        txtSampleSize2.setBounds(new Rectangle(185, 145, 85, 20));

        btnOK.setText("OK");
        btnOK.setBounds(new Rectangle(80, 190, 55, 25));
        btnOK.setActionCommand("OK");
        btnOK.addActionListener(this);
        btnExit.setText("Exit");
        btnExit.setBounds(new Rectangle(150, 190, 55, 25));
        btnExit.setActionCommand("Exit");
        btnExit.addActionListener(this);
        btnClear.setText("Clear");
        btnClear.setBounds(new Rectangle(220, 190, 65, 25));
        btnClear.setActionCommand("Clear");
        btnClear.addActionListener(this);
        btnPrint.setText("Print Results");
        btnPrint.setBounds(new Rectangle(290, 190, 120, 25));
        btnPrint.setActionCommand("Print");
        btnPrint.addActionListener(this);

        lblResult.setText("Estimated Statistical Power");
        lblResult.setBounds(new Rectangle(10, 225, 180, 30));
        lblResult.setForeground(new Color(158, 0, 0));
        lblResult.setFont(new Font("Dialog", 1, 13));
        txtResult.setText("");
        txtResult.setFont(new Font("Dialog", 1, 12));
        txtResult.setBounds(new Rectangle(10, 255, 465, 140));
       // txtResult.setBorder(BorderFactory.createMatteBorder(1, 5, 1, 1, new Color(158, 0, 0)));
        txtResult.setEditable(false);

        this.getContentPane().add(lblTitle, null);
        this.getContentPane().add(lblCorrelation1, null);
        this.getContentPane().add(txtCorrelation1, null);
        this.getContentPane().add(lblCorrelation2, null);
        this.getContentPane().add(txtCorrelation2, null);
        this.getContentPane().add(lblSampleSize1, null);
        this.getContentPane().add(txtSampleSize1, null);
        this.getContentPane().add(lblSampleSize2, null);
        this.getContentPane().add(txtSampleSize2, null);
        this.getContentPane().add(btnOK, null);
        this.getContentPane().add(btnExit, null);
        this.getContentPane().add(btnClear, null);
        this.getContentPane().add(btnPrint, null);
        this.getContentPane().add(lblResult, null);
        this.getContentPane().add(txtResult, null);
    }

    public static void main(String[] args) {
        PowerFrame frame = new PowerFrame();
        Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
        Dimension frameSize = frame.getSize();
        if(frameSize.height > screenSize.height) {
            frameSize.height = screenSize.height;
        }
        if(frameSize.width > screenSize.width) {
            frameSize.width = screenSize.width;
        }
        frame.setLocation((screenSize.width - frameSize.width) / 2, (screenSize.height - frameSize.height) / 2);
        frame.addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
                System.exit(0);
            }
        });
        frame.setVisible(true);
    }

    public void actionPerformed(ActionEvent e) {
        if(e.getActionCommand().equals("OK")) {
            if(validateInput() == true) {
                estimatePower();
            }
        }
        else if(e.getActionCommand().equals("Exit")) {
            this.hide();
            this.dispose();
        }
        else if(e.getActionCommand().equals("Clear")) {
            txtCorrelation1.setText("");
            txtCorrelation2.setText("");
            txtSampleSize1.setText("");
            txtSampleSize2.setText("");
            txtResult.setText("");
        }
        else if(e.getActionCommand().equals("Print")) {
            java.awt.Component c = (java.awt.Component) txtResult;
            PrintUtil.printComponent(c);
        }
    }

    /**
     * Prompts the user to provide all required input values.
     * @return  <code>true</code> if all the appropriate input is provided;
     * <code>false</code> if any field is empty inapprriate.
     */
    private boolean validateInput() {
        if((txtCorrelation1.getText().equals("") || txtCorrelation2.getText().equals("")
                || txtSampleSize1.getText().equals("") || txtSampleSize2.getText().equals(""))) {
            JOptionPane.showMessageDialog(null, "Please provide all values.", "Alert", JOptionPane.ERROR_MESSAGE);
            return false;
        }
        else {
            try {
                this.corr1 = Double.parseDouble(txtCorrelation1.getText());
                this.corr2 = Double.parseDouble(txtCorrelation2.getText());
                this.sample1 = Double.parseDouble(txtSampleSize1.getText());
                this.sample2 = Double.parseDouble(txtSampleSize2.getText());

                if((corr1 >= 1 || corr1 <= -1)) {
                    JOptionPane.showMessageDialog(null,
                            "Correlation values must be between (+ 1 to -1). Ex: 0.4 ",
                            "Alert",
                            JOptionPane.ERROR_MESSAGE);
                    txtCorrelation1.setText("");
                    txtCorrelation1.requestFocus();
                    return false;
                }

                if((corr2 >= 1 || corr2 <= -1)) {
                    JOptionPane.showMessageDialog(null,
                            "Correlation values must be between (+ 1 to -1). Ex: 0.4 ",
                            "Alert",
                            JOptionPane.ERROR_MESSAGE);
                    txtCorrelation2.setText("");
                    txtCorrelation2.requestFocus();
                    return false;
                }

                if((sample1 >= 0 && sample1 < 1)) {
                    JOptionPane.showMessageDialog(null,
                            "Sample size must be a whole number greater than or equal to 1.",
                            "Alert",
                            JOptionPane.ERROR_MESSAGE);
                    txtSampleSize1.setText("");
                    txtSampleSize1.requestFocus();
                    return false;
                }

                if((sample2 >= 0 && sample2 < 1)) {
                    JOptionPane.showMessageDialog(null,
                            "Sample size must be a whole number greater than or equal to 1.",
                            "Alert",
                            JOptionPane.ERROR_MESSAGE);
                    txtSampleSize2.setText("");
                    txtSampleSize2.requestFocus();
                    return false;
                }

            }
            catch(NumberFormatException nfe) {
                JOptionPane.showMessageDialog(null,
                        "Only numbers are allowed. Please verify the input.",
                        "Alert",
                        JOptionPane.ERROR_MESSAGE);

                return false;
            }
            catch(Exception e) {
                e.printStackTrace();
            }
        }
        return true;
    }

    /**
     * Takes the values from the user and performs the statistical estimation.
     */
    private void estimatePower() {
        double result1, result2, zdiff;
        double p1totn, p1zdiff, totnzdif, totnzdp1,totn, p1;

        result1 = 0.5 * Math.log((1.0 + corr1) / (1.0 - corr1));
        result2 = 0.5 * Math.log((1.0 + corr2) / (1.0 - corr2));
        zdiff = Math.abs(result1 - result2);

        totn = sample1 + sample2;
        p1 = sample1 / totn;
        p1totn = p1 * totn;
        p1zdiff = p1 * zdiff;
        totnzdif = totn * zdiff;
        totnzdp1 = p1 * totn * zdiff;

        estimate = .007088 + (-.46 * p1) +
                (-.000623 * totn) + (.09 * zdiff) +
                (.00414 * totnzdif) + (1.64 * p1zdiff) +
                (.00498 * p1totn) + (-.00738 * totnzdp1);

        NumberFormat df = NumberFormat.getInstance();
        df.setMaximumFractionDigits(2);
        df.setMinimumFractionDigits(2);

        if(estimate >= 1) {
            estimate = 1;
        }
        else if(estimate <= 0) {
            estimate = 0;
        }

        txtResult.setText("");
        txtResult.append("Correlation for Subgroup 1   : " + df.format(corr1) + "\n");
        txtResult.append("Correlation for Subgroup 2   : " + df.format(corr2) + "\n");

        df.setMaximumFractionDigits(0);

        txtResult.append("Sample size for Subgroup 1   : " + df.format(sample1) + "\n");
        txtResult.append("Sample size for Subgroup 2   : " + df.format(sample2) + "\n");
        txtResult.append("\n\n");

        df.setMaximumFractionDigits(3);
        txtResult.append("Estimated Statistical Power    : " + df.format(estimate));
    }
}